//++
//|                                                              JQS UGA |
//|                                       Copyright  2010, JQS aka Joo. |
//|                                     http://www.mql4.com/ru/users/joo |
//++
#property copyright "Copyright  2010, JQS aka Joo."                   //|
#property link      "http://www.mql4.com/ru/users/joo"                 //|
//++

//++
#property show_inputs                                                  //|
//++

//
//---------------------- --------------------------------
extern string GenofundParam         =        "---- ----";
extern int    ChromosomeCount_P     = 50;    //-   
extern int    GeneCount_P           = 2;     //- 
extern int    FFNormalizeDigits_P   = 4;     //-  
extern int    GeneNormalizeDigits_P = 4;     //-  
extern int    Epoch_P               = 50;    //-   
//---
extern string GA_OperatorParam      =        "---- ----";
extern double ReplicationPortion_P  = 100.0; // .
extern double NMutationPortion_P    = 10.0;  //  .
extern double ArtificialMutation_P  = 10.0;  //  .
extern double GenoMergingPortion_P  = 20.0;  //  .
extern double CrossingOverPortion_P = 20.0;  // .
//---
extern double ReplicationOffset_P   = 0.5;   //   
extern double NMutationProbability_P= 5.0;   //     %
//---
extern string OptimisationParam     =        "---- ----";
extern double RangeMinimum_P        = -5.0;  //  
extern double RangeMaximum_P        = 5.0;   //  
extern double Precision_P           = 0.0001;// 
extern int    OptimizeMethod_P      = 1;     //.:1-Min,-Max
//

//
//---------------------- -----------------------------
double ERROR=0.0;//   
//

#include "UGAlib.mqh"
#include "Skin.mqh"// 

//
//-------------------------- --------------------------------
int start()
{
  //------------------------------------------------------------
  //    UGA
  ChromosomeCount=ChromosomeCount_P; //-   
  GeneCount      =GeneCount_P;       //- 
  RangeMinimum   =RangeMinimum_P;    //  
  RangeMaximum   =RangeMaximum_P;    //  
  Precision      =Precision_P;       // 
  OptimizeMethod =OptimizeMethod_P;  //1-,  -
  ArrayResize(Chromosome,GeneCount+1);
  ArrayInitialize(Chromosome,0);
  Epoch=Epoch_P;                     //-   
  //----------------------------------------------------------------------
  // 
  int time_start=GetTickCount(),time_end=0;
  //----------------------------------------------------------------------

  //  - UGA
  UGA
  (
  ReplicationPortion_P, // .
  NMutationPortion_P,   //  .
  ArtificialMutation_P, //  .
  GenoMergingPortion_P, //  .
  CrossingOverPortion_P,// .
  //---
  ReplicationOffset_P,  //   
  NMutationProbability_P//     %
  );
  //----------------------------------
  time_end=GetTickCount();
  //----------------------------------
  Print(time_end-time_start,"  -  ");
  //----------------------------------
  return(0);
}
//