//-----------------------------------------------------------------------+
//    .   UGA.            |
//      .                   |
//-----------------------------------------------------------------------+
//========Skin============================================================
//(-5..5)
//MIN(3.07021;3.315935)= -4.3182  
//MAX(-3.315699;-3.072485)= 14.0606   
void FitnessFunction(int chromos)
{
  double x1 =0.0;
  double x2 =0.0;
  double sum=0.0;
  int    cnt=1;

  while(cnt<=GeneCount)
  {
    x1=Colony[cnt][chromos];
    cnt++;
    x2=Colony[cnt][chromos];
    cnt++;
    sum+=MathPow(MathCos(2.0 * x1 * x1) - 1.1, 2.0) + MathPow(MathSin(0.5 *  x1) - 1.2, 2.0) - MathPow(MathCos(2.0 * x2 * x2) - 1.1, 2.0) + MathPow(MathSin(0.5 * x2) - 1.2, 2.0);
  }
  AmountStartsFF++;
  Colony[0][chromos]=sum;
}
//

//-----------------------------------------------------------------------+
//  .   UGA.                                 |
//     ,    :              |
//   void ServiceFunction()                                              |
//   {                                                                   |
//   }                                                                   |
//-----------------------------------------------------------------------+
void ServiceFunction()
{ 
  double x1 =0.0;
  double x2 =0.0;
  int    cnt=1;
  ERROR=0.0;

  if(OptimizeMethod==1)
  {
    while(cnt<=GeneCount)
    {
      x1=Chromosome[cnt];
      ERROR+=MathAbs(3.0702-x1);
      cnt++;
      x2=Chromosome[cnt];
      ERROR+=MathAbs(3.3159-x2);
      cnt++;
    }
    ERROR=ERROR/GeneCount;
    Comment("Fitness func =",Chromosome[0],"\n",
            "  :","\n",
            "x1 = 3.0702","\n",
            "x2 = 3.3159","\n",
            "  :","\n",
            "x1 =",Chromosome[1],"\n",
            "x2 =",Chromosome[2],"\n",
            " ","\n",
            "   =",ERROR);
  }
  else
  {
    while(cnt<=GeneCount)
    {
      x1=Chromosome[cnt];
      ERROR+=MathAbs(-3.3157-x1);
      cnt++;
      x2=Chromosome[cnt];
      ERROR+=MathAbs(-3.0725-x2);
      cnt++;
    }
    ERROR=ERROR/GeneCount;
    Comment("Fitness func =",Chromosome[0],"\n",
            "  :","\n",
            "x1 = -3.3157","\n",
            "x2 = -3.0725","\n",
            "  :","\n",
            "x1 =",Chromosome[1],"\n",
            "x2 =",Chromosome[2],"\n",
            " ","\n",
            "   =",ERROR);
  }
}
//